CREATE TABLE `peaks_location` (
  `id` int(11) NOT NULL,
  `name` varchar(250) NOT NULL,
  `elevation` int(11) NOT NULL,
  `latitude` float NOT NULL,
  `longitude` float NOT NULL,
  `prominence` int(11) NOT NULL,
  `range_name` varchar(250) NOT NULL,
  `isolation` float NOT NULL,
  `state` varchar(2) NOT NULL,
  `wa_bulger_list` varchar(5) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1



INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (1, 'Mount Rainier', 14411, 46.8529, -121.76, 13, 'South Washington Cascades', 731.2, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (2, 'Mount Shasta', 14162, 41.409, -122.195, 9822, 'California Cascades', 334.7, 'CA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (3, 'Liberty Cap', 14112, 46.863, -121.775, 472, 'South Washington Cascades', 0.8, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (4, 'Shastina', 12330, 41.4093, -122.223, 450, 'California Cascades', 1.5, 'CA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (5, 'Mount Adams', 12276, 46.2025, -121.491, 8116, 'South Washington Cascades', 45.8, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (6, 'Mount Hood', 11239, 45.3735, -121.696, 7706, 'Oregon Cascades', 57.3, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (7, 'Little Tahoma', 11138, 46.8497, -121.712, 818, 'South Washington Cascades', 2.1, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (8, 'Mount Baker', 10781, 48.7768, -121.814, 8812, 'North Cascades', 131.5, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (9, 'Glacier Peak', 10520, 48.1118, -121.114, 7498, 'North Cascades', 56, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (10, 'Mount Jefferson', 10497, 44.6743, -121.8, 5777, 'Oregon Cascades', 48.1, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (11, 'Lassen Peak', 10457, 40.4882, -121.505, 5229, 'California Cascades', 71.4, 'CA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (12, 'South Sister', 10358, 44.1035, -121.769, 5598, 'Oregon Cascades', 39.4, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (13, 'Sherman Peak', 10160, 48.7674, -121.814, 400, 'North Cascades', 0.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (14, 'North Sister', 10085, 44.1666, -121.772, 2725, 'Oregon Cascades', 4.4, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (15, 'Middle Sister', 10047, 44.1484, -121.784, 1127, 'Oregon Cascades', 1.4, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (16, 'Bonanza Peak', 9511, 48.2382, -120.866, 3711, 'North Cascades', 14.4, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (17, 'Mount McLoughlin', 9495, 42.4446, -122.316, 4455, 'Oregon Cascades', 69.5, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (18, 'Colfax Peak', 9440, 48.7716, -121.844, 400, 'North Cascades', 1.4, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (19, 'Mount Stuart', 9415, 47.4752, -120.902, 5354, 'South Washington Cascades', 44.5, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (20, 'Mount Fernow', 9249, 48.1625, -120.808, 2811, 'North Cascades', 5.9, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (21, 'Brokeoff Mountain', 9235, 40.4456, -121.56, 915, 'California Cascades', 4.1, 'CA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (22, 'Eagle Peak', 9222, 40.4773, -121.519, 422, 'California Cascades', 1.1, 'CA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (23, 'Goode Mountain', 9200, 48.4831, -120.911, 3808, 'North Cascades', 17, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (24, 'Mount Thielsen', 9182, 43.1528, -122.067, 3342, 'Oregon Cascades', 50.4, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (25, 'Broken Top', 9175, 44.083, -121.699, 2175, 'Oregon Cascades', 3.4, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (26, 'Mount Shuksan', 9131, 48.8313, -121.603, 4411, 'North Cascades', 10.4, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (27, 'Mount Buckner', 9114, 48.4943, -121, 3034, 'North Cascades', 4.1, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (28, 'Broken Top-South Peak', 9094, 44.0781, -121.701, 454, 'Oregon Cascades', 0.3, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (29, 'Mount Logan', 9087, 48.5367, -120.953, 1487, 'North Cascades', 3.5, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (30, 'Mount Diller', 9085, 40.4642, -121.545, 605, 'California Cascades', 1.5, 'CA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (31, 'Lincoln Peak', 9080, 48.7684, -121.859, 720, 'North Cascades', 0.6, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (32, 'Jack Mountain', 9066, 48.7728, -120.956, 4211, 'North Cascades', 16.3, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (33, 'Mount Bachelor', 9065, 43.9793, -121.688, 2665, 'Oregon Cascades', 6.9, 'OR', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (34, 'Mount Maude', 9040, 48.1376, -120.804, 882, 'North Cascades', 1, 'WA', 'Yes');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (35, 'Mount Elbert', 14433, 39.1177, -106.445, 9073, 'Sawatch Range', 670.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (36, 'Mount Massive', 14421, 39.1873, -106.476, 1941, 'Sawatch Range', 5.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (37, 'Mount Harvard', 14420, 38.9245, -106.321, 2327, 'Sawatch Range', 14.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (38, 'La Plata Peak', 14361, 39.0294, -106.473, 1841, 'Sawatch Range', 6.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (39, 'Blanca Peak', 14345, 37.5775, -105.486, 5326, 'Sangre de Cristo Range', 103.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (40, 'Uncompahgre Peak', 14309, 38.0717, -107.462, 4277, 'San Juan Mountains', 85.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (41, 'Crestone Peak', 14294, 37.9668, -105.585, 4534, 'Sangre de Cristo Range', 27.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (42, 'Mount Lincoln', 14286, 39.3515, -106.112, 3862, 'Central Colorado Ranges', 22.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (43, 'Grays Peak', 14270, 39.6337, -105.818, 2750, 'Front Range', 25, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (44, 'Mount Antero', 14269, 38.6739, -106.246, 2503, 'Sawatch Range', 17.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (45, 'Torreys Peak', 14267, 39.6428, -105.821, 560, 'Front Range', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (46, 'Castle Peak', 14265, 39.0096, -106.861, 2345, 'Elk Range Area', 20.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (47, 'Quandary Peak', 14265, 39.3972, -106.106, 1105, 'Central Colorado Ranges', 3.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (48, 'Mount Evans', 14264, 39.5883, -105.644, 2754, 'Front Range', 9.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (49, 'Longs Peak', 14255, 40.2549, -105.616, 2940, 'Front Range', 43.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (50, 'Mount Wilson', 14246, 37.8391, -107.992, 4024, 'San Juan Mountains', 33.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (51, 'Mount Shavano', 14229, 38.6193, -106.239, 1619, 'Sawatch Range', 3.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (52, 'Mount Princeton', 14197, 38.7491, -106.242, 2157, 'Sawatch Range', 5.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (53, 'Mount Belford', 14197, 38.9606, -106.361, 1317, 'Sawatch Range', 3.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (54, 'Crestone Needle', 14197, 37.9647, -105.577, 437, 'Sangre de Cristo Range', 0.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (55, 'Mount Yale', 14196, 38.8442, -106.314, 1876, 'Sawatch Range', 5.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (56, 'Mount Bross', 14172, 39.3355, -106.108, 292, 'Central Colorado Ranges', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (57, 'Kit Carson Mountain', 14165, 37.9797, -105.603, 1005, 'Sangre de Cristo Range', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (58, 'Maroon Peak', 14156, 39.0708, -106.989, 2316, 'Elk Range Area', 8.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (59, 'Tabeguache Peak', 14155, 38.6254, -106.251, 435, 'Sawatch Range', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (60, 'Mount Oxford', 14153, 38.9648, -106.339, 633, 'Sawatch Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (61, 'Mount Sneffels', 14150, 38.0038, -107.792, 3030, 'San Juan Mountains', 15.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (62, 'Mount Democrat', 14148, 39.3396, -106.14, 748, 'Central Colorado Ranges', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (63, 'Capitol Peak', 14130, 39.1502, -107.083, 1730, 'Elk Range Area', 7.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (64, 'Pikes Peak', 14110, 38.8405, -105.045, 5510, 'Front Range', 60.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (65, 'Snowmass Mountain', 14092, 39.1187, -107.066, 1132, 'Elk Range Area', 2.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (66, 'Windom Peak', 14087, 37.6212, -107.592, 1007, 'San Juan Mountains', 26.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (67, 'Mount Eolus', 14084, 37.6218, -107.623, 2164, 'San Juan Mountains', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (68, 'Challenger Point', 14081, 37.9804, -105.607, 281, 'Sangre de Cristo Range', 0.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (69, 'Mount Columbia', 14073, 38.9038, -106.297, 873, 'Sawatch Range', 1.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (70, 'Missouri Mountain', 14067, 38.9477, -106.379, 827, 'Sawatch Range', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (71, 'Humboldt Peak', 14064, 37.9762, -105.555, 1184, 'Sangre de Cristo Range', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (72, 'Mount Bierstadt', 14060, 39.5826, -105.669, 700, 'Front Range', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (73, 'Sunlight Peak', 14059, 37.6274, -107.596, 379, 'San Juan Mountains', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (74, 'Handies Peak', 14048, 37.913, -107.504, 1888, 'San Juan Mountains', 11.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (75, 'Culebra Peak', 14047, 37.1224, -105.186, 4807, 'Sangre de Cristo Range', 35.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (76, 'Mount Lindsey', 14042, 37.5837, -105.445, 1522, 'Sangre de Cristo Range', 2.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (77, 'Ellingwood Point', 14042, 37.5826, -105.493, 322, 'Sangre de Cristo Range', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (78, 'Little Bear Peak', 14037, 37.5666, -105.497, 357, 'Sangre de Cristo Range', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (79, 'Mount Sherman', 14036, 39.225, -106.17, 850, 'Central Colorado Ranges', 8.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (80, 'Redcloud Peak', 14034, 37.941, -107.422, 1436, 'San Juan Mountains', 4.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (81, 'Pyramid Peak', 14018, 39.0716, -106.95, 1618, 'Elk Range Area', 2.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (82, 'Wilson Peak', 14017, 37.8603, -107.985, 857, 'San Juan Mountains', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (83, 'Wetterhorn Peak', 14015, 38.0607, -107.511, 1615, 'San Juan Mountains', 2.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (84, 'San Luis Peak', 14014, 37.9868, -106.931, 3113, 'San Juan Mountains', 27, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (85, 'Mount of the Holy Cross', 14005, 39.4667, -106.482, 2111, 'Sawatch Range', 18.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (86, 'Huron Peak', 14003, 38.9455, -106.438, 1403, 'Sawatch Range', 3.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (87, 'Sunshine Peak', 14001, 37.9228, -107.426, 481, 'San Juan Mountains', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (88, 'Grizzly Peak', 13988, 39.0425, -106.598, 1908, 'Sawatch Range', 6.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (89, 'Stewart Peak', 13983, 38.0231, -106.924, 863, 'San Juan Mountains', 2.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (90, 'Pigeon Peak', 13972, 37.6324, -107.647, 1132, 'San Juan Mountains', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (91, 'Mount Ouray', 13971, 38.4227, -106.225, 2659, 'Sawatch Range', 13.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (92, 'Columbia Point', 13960, 37.979, -105.598, 320, 'Sangre de Cristo Range', 0.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (93, 'Ice Mountain', 13951, 38.915, -106.437, 991, 'Sawatch Range', 2.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (94, 'Fletcher Mountain', 13951, 39.4032, -106.129, 591, 'Central Colorado Ranges', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (95, 'Pacific Peak', 13950, 39.4231, -106.123, 550, 'Central Colorado Ranges', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (96, 'Cathedral Peak', 13943, 39.0344, -106.859, 503, 'Elk Range Area', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (97, 'French Mountain', 13940, 39.1285, -106.482, 1060, 'Sawatch Range', 2.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (98, 'Mount Hope', 13933, 39.0211, -106.42, 853, 'Sawatch Range', 2.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (99, 'Thunder Peak', 13932, 39.0627, -106.952, 292, 'Elk Range Area', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (100, 'Mount Adams', 13931, 38.0073, -105.605, 851, 'Sangre de Cristo Range', 1.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (101, 'Gladstone Peak', 13913, 37.8451, -107.984, 713, 'San Juan Mountains', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (102, 'Mount Meeker', 13911, 40.2485, -105.605, 431, 'Front Range', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (103, 'Casco Peak', 13908, 39.114, -106.494, 628, 'Sawatch Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (104, 'Red Mountain', 13908, 37.1123, -105.181, 428, 'Sangre de Cristo Range', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (105, 'Emerald Peak', 13904, 38.929, -106.381, 544, 'Sawatch Range', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (106, 'Horseshoe Mountain', 13898, 39.1858, -106.185, 738, 'Central Colorado Ranges', 2.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (107, 'Phoenix Peak', 13895, 37.9363, -106.866, 1495, 'San Juan Mountains', 5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (108, 'Vermilion Peak', 13894, 37.7993, -107.829, 2105, 'San Juan Mountains', 9.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (109, 'North Carbonate Mountain', 13870, 38.6554, -106.283, 1030, 'Sawatch Range', 2.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (110, 'Mount Buckskin', 13865, 39.3187, -106.147, 679, 'Central Colorado Ranges', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (111, 'Vestal Peak', 13864, 37.6894, -107.603, 1104, 'San Juan Mountains', 4.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (112, 'Jones Mountain', 13860, 37.8965, -107.527, 500, 'San Juan Mountains', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (113, 'Clinton Peak', 13857, 39.3682, -106.149, 497, 'Central Colorado Ranges', 2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (114, 'Dyer Mountain', 13855, 39.2398, -106.183, 455, 'Central Colorado Ranges', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (115, 'Crystal Peak', 13852, 39.4345, -106.115, 612, 'Central Colorado Ranges', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (116, 'Mount Edwards', 13850, 39.6364, -105.794, 450, 'Front Range', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (117, 'California Peak', 13849, 37.614, -105.499, 609, 'Sangre de Cristo Range', 2.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (118, 'Mount Oklahoma', 13845, 39.1787, -106.506, 725, 'Sawatch Range', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (119, 'Atlantic Peak', 13841, 39.4135, -106.126, 1481, 'San Juan Mountains', 3.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (120, 'Half Peak', 13841, 37.8646, -107.468, 401, 'Central Colorado Ranges', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (121, 'Hagerman Peak', 13841, 39.1119, -107.06, 321, 'Elk Range Area', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (122, 'North Apostle', 13840, 38.9198, -106.434, 360, 'Sawatch Range', 0.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (123, 'Turret Peak', 13835, 37.6276, -107.64, 715, 'San Juan Mountains', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (124, 'Redcloud Peak-Northeast Peak', 13832, 37.9471, -107.398, 792, 'San Juan Mountains', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (125, 'Holy Cross Ridge', 13831, 39.4589, -106.486, 311, 'Sawatch Range', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (126, 'Jupiter Mountain', 13830, 37.6125, -107.592, 350, 'San Juan Mountains', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (127, 'Iron Nipple-Northeast Peak', 13828, 37.6003, -105.448, 668, 'Sangre de Cristo Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (128, 'Jagged Mountain', 13824, 37.6456, -107.584, 944, 'San Juan Mountains', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (129, 'Casco Peak-Southwest Peak', 13823, 39.0934, -106.512, 863, 'Sawatch Range', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (130, 'Mount Silverheels', 13822, 39.3393, -106.005, 2283, 'Front Range', 5.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (131, 'Rio Grande Pyramid', 13821, 37.6796, -107.392, 1861, 'San Juan Mountains', 10.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (132, 'Teakettle Mountain', 13819, 38.0006, -107.762, 739, 'San Juan Mountains', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (133, 'Redcloud Peak-Far Northeast Peak', 13811, 37.9546, -107.378, 531, 'San Juan Mountains', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (134, 'Dallas Peak', 13809, 37.9883, -107.824, 849, 'San Juan Mountains', 2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (135, 'Niagara Peak', 13807, 37.8893, -107.534, 567, 'San Juan Mountains', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (136, 'Handies Peak-SSW Peak', 13806, 37.8995, -107.513, 446, 'San Juan Mountains', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (137, 'Trinity Peaks', 13805, 37.685, -107.581, 925, 'San Juan Mountains', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (138, 'Arrow Peak', 13803, 37.6928, -107.61, 923, 'San Juan Mountains', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (139, 'Castle Peak-West Peak', 13803, 39.0073, -106.876, 403, 'Elk Range Area', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (140, 'Organ Mountain', 13801, 37.9912, -106.895, 694, 'San Juan Mountains', 2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (141, 'Kit Carson Mountain-Far East Peak', 13799, 37.9784, -105.588, 319, 'Sangre de Cristo Range', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (142, 'Handies Peak-ESE Peak', 13795, 37.9087, -107.481, 555, 'Central Colorado Ranges', 1.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (143, 'Mount Arkansas', 13795, 39.3324, -106.178, 475, 'San Juan Mountains', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (144, 'Rito Alto Peak', 13794, 38.1028, -105.661, 1114, 'Sangre de Cristo Range', 7.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (145, 'Square Top Mountain', 13794, 39.5932, -105.763, 794, 'Front Range', 3.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (146, 'Animas Mountain', 13786, 37.6432, -107.629, 1066, 'San Juan Mountains', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (147, 'Potosi Peak', 13786, 37.9897, -107.749, 786, 'San Juan Mountains', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (148, 'Rinker Peak', 13783, 39.0368, -106.44, 903, 'Sawatch Range', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (149, 'Mosquito Peak', 13781, 39.3002, -106.183, 541, 'Central Colorado Ranges', 2.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (150, 'Holy Cross Ridge-Middle Peak', 13768, 39.4482, -106.489, 368, 'Sawatch Range', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (151, 'U S Grant Peak', 13767, 37.8245, -107.807, 727, 'San Juan Mountains', 2.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (152, 'Trinity Peaks-West Peak', 13765, 37.6863, -107.588, 365, 'San Juan Mountains', 0.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (153, 'Peak 13762', 13762, 38.907, -106.367, 802, 'Sawatch Range', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (154, 'Bull Hill', 13761, 39.0996, -106.463, 921, 'Sawatch Range', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (155, 'Deer Mountain', 13761, 39.1574, -106.521, 401, 'Sawatch Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (156, 'Garfield Peak', 13760, 39.0305, -106.595, 360, 'San Juan Mountains', 0.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (157, 'Golden Horn', 13760, 37.8049, -107.825, 320, 'Sawatch Range', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (158, 'San Miguel Peak', 13752, 37.7792, -107.865, 1307, 'San Juan Mountains', 2.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (159, 'Storm King Peak', 13752, 37.6766, -107.56, 592, 'San Juan Mountains', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (160, 'Mount Sheridan', 13748, 39.2091, -106.185, 588, 'Central Colorado Ranges', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (161, 'Mount Aetna', 13745, 38.5864, -106.32, 1225, 'Sawatch Range', 4.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (162, 'Trinity Peaks-East Peak', 13745, 37.6843, -107.577, 385, 'San Juan Mountains', 0.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (163, 'Pilot Knob', 13738, 37.8117, -107.829, 938, 'Sawatch Range', 1.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (164, 'Grizzly Peak', 13738, 37.7561, -107.862, 738, 'San Juan Mountains', 1.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (165, 'Sayres Benchmark', 13738, 39.0094, -106.498, 618, 'Front Range', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (166, 'Argentine Peak', 13738, 39.612, -105.777, 378, 'San Juan Mountains', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (167, 'Peak 13736', 13736, 39.1406, -106.524, 656, 'Sawatch Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (168, 'T 0', 13735, 37.9926, -107.849, 375, 'San Juan Mountains', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (169, 'Vermejo Peak', 13723, 37.0942, -105.191, 761, 'Sangre de Cristo Range', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (170, 'Pyramid Peak-Far South Peak', 13722, 39.0568, -106.954, 1042, 'San Juan Mountains', 3.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (171, 'Peak 13722', 13722, 37.9437, -107.555, 282, 'Elk Range Area', 0.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (172, 'Pole Creek Mountain', 13716, 37.796, -107.431, 1516, 'San Juan Mountains', 5.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (173, 'Silver Mountain', 13714, 38.1068, -107.449, 1034, 'San Juan Mountains', 2.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (174, 'Jones Peak West', 13712, 38.6319, -106.239, 312, 'Sawatch Range', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (175, 'Twining Peak', 13711, 39.1346, -106.563, 1231, 'Sawatch Range', 2.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (176, 'Grizzly Mountain', 13708, 38.6457, -106.311, 548, 'Sawatch Range', 1.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (177, 'Colony Baldy', 13705, 37.9956, -105.56, 905, 'Sangre de Cristo Range', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (178, 'Peak Six', 13705, 37.6604, -107.585, 665, 'San Juan Mountains', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (179, 'Baldy Alto', 13698, 38.0053, -106.921, 498, 'San Juan Mountains', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (180, 'Monitor Peak', 13695, 37.6376, -107.625, 295, 'San Juan Mountains', 0.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (181, 'Gilpin Peak', 13694, 37.9864, -107.793, 720, 'San Juan Mountains', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (182, 'Rolling Mountain', 13693, 37.7662, -107.826, 893, 'San Juan Mountains', 2.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (183, 'Every Mountain', 13691, 37.9786, -107.426, 451, 'San Juan Mountains', 2.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (184, 'Wheeler Mountain', 13690, 39.3806, -106.136, 290, 'Central Colorado Ranges', 1.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (185, 'Cooper Creek Peak', 13688, 37.9645, -107.418, 408, 'San Juan Mountains', 1.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (186, 'Peak 13688', 13688, 37.954, -107.54, 368, 'San Juan Mountains', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (187, 'Cirque Mountain', 13686, 38.0038, -107.772, 526, 'San Juan Mountains', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (188, 'Mount Oso', 13684, 37.607, -107.494, 2099, 'Front Range', 7.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (189, 'Bald Mountain', 13684, 39.4448, -105.971, 1644, 'San Juan Mountains', 5.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (190, 'Peak Seven', 13682, 37.6678, -107.574, 402, 'San Juan Mountains', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (191, 'Peak 13681', 13681, 38.1204, -107.458, 481, 'San Juan Mountains', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (192, 'Peak Fifteen', 13680, 37.6287, -107.636, 400, 'San Juan Mountains', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (193, 'Grizzly Peak', 13680, 37.6076, -107.582, 280, 'San Juan Mountains', 0.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (194, 'Purgatoire Peak', 13676, 37.0725, -105.211, 849, 'Sangre de Cristo Range', 1.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (195, 'Quarter Peak', 13674, 37.881, -107.458, 714, 'San Juan Mountains', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (196, 'Mount Tweto', 13672, 39.3222, -106.169, 392, 'Central Colorado Ranges', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (197, 'Mount Jackson', 13670, 39.4852, -106.537, 1790, 'Sawatch Range', 3.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (198, 'Mount White', 13667, 38.6568, -106.238, 827, 'Sawatch Range', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (199, 'Carbonate Mountain', 13663, 38.6268, -106.286, 434, 'Sawatch Range', 1.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (200, 'Lookout Peak', 13661, 37.8621, -107.78, 821, 'San Juan Mountains', 3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (201, 'Carson Peak', 13657, 37.8575, -107.402, 1217, 'San Juan Mountains', 3.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (202, 'Coxcomb Peak', 13656, 38.0801, -107.534, 776, 'San Juan Mountains', 1.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (203, 'Taylor Mountain', 13651, 38.5834, -106.3, 611, 'Sawatch Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (204, 'Mount Mamma', 13646, 38.6696, -106.318, 526, 'Sawatch Range', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (205, 'Mount Champion', 13646, 39.1321, -106.521, 286, 'Sawatch Range', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (206, 'Redcliff', 13642, 38.0873, -107.533, 482, 'San Juan Mountains', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (207, 'Bard Peak', 13641, 39.7204, -105.804, 1681, 'Front Range', 5.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (208, 'Northwest Pole', 13640, 37.8141, -107.446, 800, 'San Juan Mountains', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (209, 'Peak 13640', 13640, 37.5986, -105.501, 360, 'Sangre de Cristo Range', 1.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (210, 'Wood Mountain', 13640, 37.9476, -107.538, 280, 'San Juan Mountains', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (211, 'Electric Pass Peak', 13635, 39.0474, -106.853, 315, 'Elk Range Area', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (212, 'Peak 10', 13633, 39.4433, -106.103, 353, 'Central Colorado Ranges', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (213, 'Anderson Peak', 13631, 39.0122, -106.63, 951, 'Sawatch Range', 2.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (214, 'Peak 13631', 13631, 39.0473, -106.959, 311, 'Elk Range Area', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (215, 'Mount Silex', 13628, 37.6704, -107.548, 788, 'San Juan Mountains', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (216, 'White Dome', 13627, 37.7042, -107.547, 947, 'San Juan Mountains', 2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (217, 'Peak 13626', 13626, 38.7536, -106.268, 3666, 'Sangre de Cristo Range', 20.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (218, 'West Spanish Peak', 13626, 37.3756, -104.993, 466, 'Sawatch Range', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (219, 'The Guardian', 13617, 37.6635, -107.54, 537, 'San Juan Mountains', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (220, 'Mount Blaurock', 13616, 39.0114, -106.454, 416, 'Sawatch Range', 1.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (221, 'North Star Mountain', 13614, 39.3767, -106.121, 414, 'Central Colorado Ranges', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (222, 'Pico Asilado', 13611, 37.9443, -105.559, 811, 'Sangre de Cristo Range', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (223, 'Tijeras Peak', 13604, 37.9246, -105.54, 724, 'Sangre de Cristo Range', 1.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (224, 'Gray Wolf', 13602, 39.6174, -105.661, 562, 'Front Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (225, 'Cyclone Mountain', 13596, 38.6333, -106.292, 316, 'Sawatch Range', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (226, 'Electric Peak', 13595, 38.1819, -105.708, 915, 'Sangre de Cristo Range', 6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (227, 'Matterhorn Peak', 13590, 38.0653, -107.496, 550, 'San Juan Mountains', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (228, 'Peak One', 13589, 37.6975, -107.557, 389, 'San Juan Mountains', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (229, 'Cottonwood Peak', 13588, 38.2194, -105.757, 1108, 'Sangre de Cristo Range', 3.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (230, 'Peak 13581', 13581, 37.8366, -107.395, 661, 'San Juan Mountains', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (231, 'Mount Emma', 13581, 37.9749, -107.79, 541, 'San Juan Mountains', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (232, 'Chiefs Head Peak', 13579, 40.2496, -105.642, 699, 'Front Range', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (233, 'Mount Evans', 13577, 39.2567, -106.182, 297, 'Central Colorado Ranges', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (234, 'Peak 13577', 13577, 37.6008, -105.493, 297, 'Sangre de Cristo Range', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (235, 'Greylock Mountain', 13575, 37.6175, -107.57, 655, 'Front Range', 3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (236, 'Rosalie Peak', 13575, 39.556, -105.607, 535, 'San Juan Mountains', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (237, 'Mount Parnassus', 13574, 39.7202, -105.823, 537, 'Front Range', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (238, 'Broken Hand Peak', 13573, 37.9569, -105.567, 653, 'Sangre de Cristo Range', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (239, 'West Apostle', 13568, 38.9144, -106.448, 488, 'Sawatch Range', 0.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (240, 'Gudy Peak', 13566, 37.9745, -107.46, 726, 'San Juan Mountains', 1.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (241, 'Peak 13565', 13565, 37.1401, -105.176, 525, 'Sangre de Cristo Range', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (242, 'Hagues Peak', 13560, 40.4845, -105.646, 2960, 'Central Colorado Ranges', 21.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (243, 'Twin Peaks', 13560, 37.59, -105.519, 2400, 'Front Range', 15.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (244, 'Clark Peak', 13560, 39.1522, -107.062, 600, 'Sangre de Cristo Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (245, 'Peak 13560', 13560, 38.0007, -105.6, 400, 'Elk Range Area', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (246, 'Peak 13560', 13560, 37.8377, -107.418, 400, 'Sangre de Cristo Range', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (247, 'Mount Powell', 13560, 39.7601, -106.341, 320, 'San Juan Mountains', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (248, 'Wasatch Mountain', 13555, 37.8901, -107.796, 475, 'San Juan Mountains', 2.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (249, 'Fluted Peak', 13554, 38.0246, -105.601, 714, 'Sangre de Cristo Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (250, 'McCauley Peak', 13554, 37.5976, -107.578, 434, 'San Juan Mountains', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (251, 'Gibbs Peak', 13553, 38.1639, -105.666, 1563, 'Front Range', 4.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (252, 'Pettingell Peak', 13553, 39.7286, -105.905, 673, 'Sangre de Cristo Range', 2.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (253, 'Tower Mountain', 13552, 37.8573, -107.623, 1632, 'San Juan Mountains', 4.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (254, 'Peak 13550', 13550, 38.9944, -106.878, 510, 'Elk Range Area', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (255, 'Peak 13546', 13546, 38.0036, -105.619, 626, 'Sangre de Cristo Range', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (256, 'Whitecross Mountain', 13542, 37.9306, -107.493, 542, 'San Juan Mountains', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (257, 'Peak 13541', 13541, 37.9916, -105.592, 341, 'Sangre de Cristo Range', 0.8, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (258, 'Emma Burr Mountain', 13538, 38.7336, -106.417, 1218, 'Sawatch Range', 6.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (259, 'Peak 13537', 13537, 39.0147, -106.913, 737, 'Elk Range Area', 2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (260, 'K 49', 13535, 39.1521, -106.501, 535, 'Sawatch Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (261, 'Peak 13535', 13535, 37.9179, -107.532, 495, 'San Juan Mountains', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (262, 'Ervin Peak', 13531, 39.0038, -106.439, 411, 'Sawatch Range', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (263, 'Epaulie', 13530, 39.5668, -105.623, 330, 'Front Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (264, 'Boulder Mountain', 13528, 38.6803, -106.293, 2808, 'Elk Range Area', 6.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (265, 'Leviathan Peak', 13528, 37.653, -107.575, 568, 'Sawatch Range', 1.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (266, 'V 3', 13528, 37.8287, -107.813, 568, 'San Juan Mountains', 0.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (267, 'Treasure Mountain', 13528, 39.0244, -107.123, 368, 'San Juan Mountains', 0.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (268, 'Peak of the Clouds', 13524, 38.1175, -105.658, 604, 'Sangre de Cristo Range', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (269, 'Cataract Peak', 13524, 37.8681, -107.424, 444, 'San Juan Mountains', 1.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (270, 'Epaulet Mountain', 13523, 39.5706, -105.632, 323, 'Front Range', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (271, 'Milwaukee Peak', 13522, 37.9477, -105.551, 282, 'Sangre de Cristo Range', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (272, 'Star Peak', 13521, 38.9796, -106.8, 816, 'Elk Range Area', 3.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (273, 'White Rock Mountain', 13520, 38.9806, -106.928, 760, 'Elk Range Area', 2.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (274, 'Peak 13520', 13520, 37.9618, -107.496, 480, 'San Juan Mountains', 2.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (275, 'Peak 13520', 13520, 37.8568, -108.002, 480, 'San Juan Mountains', 1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (276, 'Peak Eleven', 13520, 37.6287, -107.606, 360, 'San Juan Mountains', 0.5, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (277, 'V 4', 13520, 37.8208, -107.812, 280, 'San Juan Mountains', 0.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (278, 'Peak 13517', 13517, 38.9282, -106.422, 957, 'Sangre de Cristo Range', 10.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (279, 'Trinchera Peak', 13517, 37.2891, -105.165, 437, 'Sawatch Range', 0.9, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (280, 'Keefe Peak', 13516, 39.0325, -106.904, 476, 'Elk Range Area', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (281, 'Ypsilon Mountain', 13514, 40.4571, -105.681, 1116, 'Front Range', 2.6, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (282, 'Silver Peak', 13513, 38.1292, -105.67, 433, 'Sangre de Cristo Range', 1.1, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (283, 'Peak 13510', 13510, 37.9176, -107.738, 1550, 'San Juan Mountains', 7.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (284, 'T 11', 13510, 37.8777, -107.766, 590, 'San Juan Mountains', 3.7, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (285, 'Peak 13510', 13510, 37.9663, -107.071, 452, 'San Juan Mountains', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (286, 'Eureka Mountain', 13507, 38.079, -105.641, 787, 'Sangre de Cristo Range', 2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (287, 'Petroleum Peak', 13505, 39.0244, -106.649, 505, 'Sawatch Range', 1.3, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (288, 'North Arapaho Peak', 13502, 40.0266, -105.651, 1665, 'Front Range', 15.4, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (289, 'Fairchild Mountain', 13502, 40.4686, -105.664, 902, 'Front Range', 1.2, 'CO', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (290, 'Mount Olympus', 7969, 47.8013, -123.711, 7838, 'Central Olympic Mountains', 108, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (291, 'Mount Deception', 7788, 47.8134, -123.233, 4108, 'North-Central Olympic Mountains', 21.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (292, 'Mount Constance', 7756, 47.7728, -123.127, 1956, 'Eastern Olympic Mountains', 5.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (293, 'Mount Johnson', 7680, 47.8327, -123.237, 480, 'North-Central Olympic Mountains', 1.3, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (294, 'Inner Constance', 7667, 47.7699, -123.146, 1147, 'Eastern Olympic Mountains', 0.9, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (295, 'Mount Mystery', 7639, 47.7959, -123.221, 1119, 'North-Central Olympic Mountains', 1.3, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (296, 'Mount Clark', 7528, 47.8356, -123.232, 608, 'North-Central Olympic Mountains', 0.3, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (297, 'Athena', 7365, 47.7815, -123.69, 1965, 'Central Olympic Mountains', 7.8, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (298, 'West Peak', 7365, 47.7232, -123.349, 525, 'Central Olympic Mountains', 1.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (299, 'Mount Anderson', 7321, 47.7212, -123.332, 721, 'Central Olympic Mountains', 0.8, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (300, 'Warrior Peak', 7320, 47.7841, -123.134, 760, 'Eastern Olympic Mountains', 0.8, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (301, 'Gray Wolf Ridge', 7218, 47.8812, -123.207, 818, 'North-Central Olympic Mountains', 2.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (302, 'Mount Cameron', 7190, 47.8259, -123.334, 990, 'North-Central Olympic Mountains', 4.5, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (303, 'Hal Foss Peak', 7179, 47.7995, -123.209, 419, 'North-Central Olympic Mountains', 0.6, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (304, 'Mount Mathias', 7156, 47.8051, -123.677, 996, 'Central Olympic Mountains', 1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (305, 'Mount Fricaba', 7139, 47.8081, -123.2, 539, 'North-Central Olympic Mountains', 0.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (306, 'Gray Wolf Ridge-South Peak', 7076, 47.8627, -123.222, 716, 'Central Olympic Mountains', 2.3, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (307, 'Mount Tom', 7076, 47.793, -123.758, 676, 'North-Central Olympic Mountains', 1.2, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (308, 'Gray Wolf Pass NW', 7060, 47.8247, -123.283, 740, 'North-Central Olympic Mountains', 2.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (309, 'Point Harrah', 7040, 47.761, -123.132, 440, 'Eastern Olympic Mountains', 0.5, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (310, 'North Petunia Peak', 6998, 47.8432, -123.197, 718, 'North-Central Olympic Mountains', 1.6, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (311, 'Mount Carrie', 6995, 47.8942, -123.649, 1675, 'Central Olympic Mountains', 6.3, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (312, 'Buckhorn Mountain', 6988, 47.8256, -123.122, 988, 'Eastern Olympic Mountains', 2.8, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (313, 'Petunia Peak', 6953, 47.8343, -123.196, 433, 'North-Central Olympic Mountains', 0.6, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (314, 'Mercury', 6950, 47.8203, -123.671, 750, 'Central Olympic Mountains', 1.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (315, 'Little Mystery', 6941, 47.7868, -123.225, 581, 'North-Central Olympic Mountains', 0.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (316, 'Mount Worthington', 6938, 47.8372, -123.1, 498, 'Eastern Olympic Mountains', 1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (317, 'Chimney Peak', 6917, 47.6894, -123.403, 997, 'Central Olympic Mountains', 3.4, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (318, 'Mount Fairchild', 6900, 47.9001, -123.633, 450, 'Central Olympic Mountains', 0.8, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (319, 'Crystal Peak', 6896, 47.7202, -123.392, 896, 'Central Olympic Mountains', 2, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (320, 'Boulder Ridge', 6852, 47.8068, -123.124, 572, 'Eastern Olympic Mountains', 1.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (321, 'Circe', 6847, 47.7873, -123.667, 447, 'Central Olympic Mountains', 0.5, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (322, 'The Brothers', 6842, 47.6538, -123.141, 2682, 'Eastern Olympic Mountains', 7.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (323, 'Mount Claywood', 6836, 47.8009, -123.37, 1236, 'North-Central Olympic Mountains', 2.4, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (324, 'Baldy', 6827, 47.895, -123.189, 547, 'North-Central Olympic Mountains', 1.2, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (325, 'Diamond Mountain', 6822, 47.7406, -123.299, 1142, 'Central Olympic Mountains', 2, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (326, 'Peak 6810', 6810, 47.8503, -123.309, 650, 'North-Central Olympic Mountains', 1.9, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (327, 'McCartney Peak', 6784, 47.8543, -123.387, 544, 'North-Central Olympic Mountains', 3.2, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (328, 'Elk Mountain', 6779, 47.9262, -123.361, 819, 'North-Central Olympic Mountains', 5.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (329, 'Moose Peak', 6760, 47.8843, -123.366, 640, 'North-Central Olympic Mountains', 2.3, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (330, 'Peak 6759', 6759, 47.872, -123.349, 599, 'North-Central Olympic Mountains', 1.2, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (331, 'Wellesley Peak', 6758, 47.7912, -123.291, 958, 'North-Central Olympic Mountains', 2.3, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (332, 'Bicentennial Peak', 6720, 47.6969, -123.391, 680, 'Central Olympic Mountains', 0.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (333, 'Mount Meany', 6695, 47.751, -123.598, 1895, 'Central Olympic Mountains', 4.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (334, 'Copper Creek Peak', 6628, 47.8526, -123.12, 708, 'Eastern Olympic Mountains', 1.4, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (335, 'Mount Stone', 6612, 47.6063, -123.267, 2132, 'Eastern Olympic Mountains', 6.7, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (336, 'Sentinel Peak', 6592, 47.7791, -123.342, 652, 'North-Central Olympic Mountains', 1.4, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (337, 'Hawk Peak', 6545, 47.8424, -123.081, 465, 'Eastern Olympic Mountains', 1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (338, 'Mount Elk Lick', 6517, 47.6886, -123.258, 1997, 'Central Olympic Mountains', 4.1, 'WA', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (339, 'Gannett Peak', 13804, 43.1844, -109.654, 7076, 'Northern Wind River Range', 290.4, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (340, 'Grand Teton', 13770, 43.7412, -110.802, 6530, 'Teton Range', 69.4, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (341, 'Fremont Peak', 13745, 43.1246, -109.618, 1184, 'Northern Wind River Range', 4.5, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (342, 'Mount Warren', 13722, 43.1637, -109.626, 962, 'Northern Wind River Range', 2, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (343, 'Mount Helen', 13620, 43.151, -109.631, 820, 'Northern Wind River Range', 0.9, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (344, 'Turret Peak', 13600, 43.1646, -109.619, 600, 'Northern Wind River Range', 0.4, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (345, 'Mount Sacagawea', 13569, 43.136, -109.624, 409, 'Northern Wind River Range', 0.8, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (346, 'Jackson Peak', 13517, 43.1195, -109.604, 717, 'Northern Wind River Range', 0.8, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (347, 'Mount Woodrow Wilson', 13502, 43.1668, -109.652, 502, 'Northern Wind River Range', 1.1, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (348, 'Bastion Peak', 13494, 43.2064, -109.665, 734, 'Northern Wind River Range', 1.6, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (349, 'Mount Febbas', 13468, 43.1757, -109.602, 708, 'Northern Wind River Range', 1.1, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (350, 'Flagstone Peak', 13450, 43.215, -109.676, 810, 'Northern Wind River Range', 0.8, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (351, 'Sunbeam Peak', 13440, 43.1705, -109.618, 560, 'Northern Wind River Range', 0.4, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (352, 'Pinnacle Ridge', 13365, 43.1734, -109.655, 325, 'Northern Wind River Range', 0.5, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (353, 'Downs Mountain', 13349, 43.3098, -109.672, 1549, 'Northern Wind River Range', 6.5, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (354, 'Mount Koven', 13265, 43.1949, -109.658, 425, 'Northern Wind River Range', 0.4, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (355, 'American Legion Peak', 13205, 43.1471, -109.666, 925, 'Northern Wind River Range', 1.5, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (356, 'Brown Cliffs North', 13198, 43.1099, -109.555, 1038, 'Northern Wind River Range', 2.6, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (357, 'Wind River Peak', 13192, 42.7085, -109.128, 2552, 'Southern Wind River Range', 35.2, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (358, 'Twin Peaks', 13185, 43.1602, -109.659, 385, 'Northern Wind River Range', 0.6, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (359, 'Cloud Peak', 13167, 44.382, -107.174, 7067, 'Central Bighorn Mountains', 145, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (360, 'Split Mountain', 13155, 43.164, -109.673, 915, 'Northern Wind River Range', 0.7, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (361, 'Desolation Peak', 13155, 43.2015, -109.68, 595, 'Northern Wind River Range', 0.7, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (362, 'Francs Peak', 13153, 43.9613, -109.339, 4056, 'Southern Absaroka Range', 47.3, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (363, 'Henderson Peak', 13115, 43.1375, -109.661, 755, 'Northern Wind River Range', 0.7, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (364, 'Klondike Peak', 13114, 43.2363, -109.689, 664, 'Northern Wind River Range', 1.3, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (365, 'South Downs Mountain', 13062, 43.2848, -109.685, 422, 'Northern Wind River Range', 1.8, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (366, 'Harrower Peak', 13052, 43.0937, -109.596, 932, 'Northern Wind River Range', 1.8, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (367, 'Bow Mountain', 13020, 43.144, -109.684, 660, 'Northern Wind River Range', 0.9, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (368, 'Mount Whitecap', 13020, 43.1687, -109.692, 580, 'Northern Wind River Range', 1, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (369, 'Black Tooth Mountain', 13005, 44.4032, -107.179, 645, 'Central Bighorn Mountains', 1.5, 'WY', 'No');
INSERT INTO php_demos.peaks_location(id, name, elevation, latitude, longitude, prominence, range_name, isolation, state, wa_bulger_list) VALUES (370, 'Knife Point Mountain', 13001, 43.1014, -109.581, 641, 'Northern Wind River Range', 0.9, 'WY', 'No');
