<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title>Peaks of North America</title>
	<meta name="generator" content="TextMate http://macromates.com/">
	<meta name="author" content="Ryan Stewart">
	<!-- Date: 2010-11-08 -->
	<style type="text/css" media="screen">
		body{ font: 62.5% "Trebuchet MS", sans-serif; margin: 50px;}
		tr.zebraHover {
			background-color: #FFFACD;
		}
	</style>
	<link type="text/css" href="css/trontastic/jquery-ui-1.8.6.custom.css" rel="stylesheet" />		
	<script type="text/javascript" src="http://maps.google.com/maps?file=api&v=2&key=ABQIAAAAEPSnxMQDa8BRcDfJB7EW1hQsjWZd4l825400JDjq6oGmuBkzpRRr9lI-LYZgy0YJ0hkBz6-8tmdBHA"></script>
	<script src="jquery-1.4.3.min.js" type="text/javascript" charset="utf-8"></script>
	<script src="jquery.dataTables.min.js" type="text/javascript" charset="utf-8"></script>
	<script src="jquery-ui-1.8.6.custom.min.js" type="text/javascript" charset="utf-8"></script>
	<script type="text/javascript" charset="utf-8">
		$(document).ready(function(){
			oTable = $('#peaks').dataTable({
				"bJQueryUI": true
			});
		});
	</script>
<?php
	function getConnection()
	{
		$username = "root";
		$password = "root";
		$server = "localhost";
		$port = "8889";
		$databasename = "php_demos";

		$connection = mysqli_connect(
							$server,  
							$username,  
							$password, 
							$databasename,
							$port
						);
						
		return $connection;		
	}

?>
</head>
<body>
<table id="peaks">
	<thead>
		<tr>
			<th>ID</th>
			<th>Name</th>
			<th>Elevation</th>
			<th>Latitude</th>
			<th>Longitude</th>
			<th>Prominence</th>
			<th>Range</th>
			<th>Isolation</th>
			<th>State</th>
			<th>WA Bulger List</th>
		</tr>
	</thead>
<?php

	$conn = getConnection();
	$query = "SELECT * FROM peaks_location";
	$stmt = mysqli_prepare($conn,$query);		

	mysqli_stmt_execute($stmt);
	mysqli_stmt_bind_result($stmt, $row->id, $row->name, $row->elevation, $row->latitude, $row->longitude, $row->prominence, $row->range, $row->isolation, $row->state, $row->wa_bulger_list);
	
	
	
	
	while (mysqli_stmt_fetch($stmt)) {
		printf ("<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>"
		, $row->id, $row->name, $row->elevation, $row->latitude, $row->longitude, $row->prominence, $row->range, $row->isolation, $row->state, $row->wa_bulger_list);
	}
	
	mysqli_stmt_free_result($stmt);
	mysqli_close($conn);

?>

<?php
	
?>
</table>
</body>
</html>
