<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN"
   "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	<title>Peaks of North America</title>
	<meta name="generator" content="TextMate http://macromates.com/">
	<meta name="author" content="Ryan Stewart">
	<!-- Date: 2010-11-08 -->
<?php
	function getConnection()
	{
		$username = "root";
		$password = "root";
		$server = "localhost";
		$port = "8889";
		$databasename = "php_demos";

		$connection = mysqli_connect(
							$server,  
							$username,  
							$password, 
							$databasename,
							$port
						);
						
		return $connection;		
	}

?>
</head>
<body>
<?php

	$conn = getConnection();
	$query = "SELECT distinct range_name FROM peaks_location";
	$stmt = mysqli_prepare($conn,$query);		

	mysqli_stmt_execute($stmt);
	mysqli_stmt_bind_result($stmt, $range);
	
	
	
	
	while (mysqli_stmt_fetch($stmt)) {
		printf ("%s | ", $range);
	}
	
	mysqli_stmt_free_result($stmt);
	mysqli_close($conn);

?>
<table>
	<tr><td>ID</td>
		<td>Name</td>
		<td>Elevation</td>
		<td>Latitude</td>
		<td>Longitude</td>
		<td>Prominence</td>
		<td>Range</td>
		<td>Isolation</td>
		<td>State</td>
		<td>WA Bulger List</td>
	</tr>
<?php

	$conn = getConnection();
	$query = "SELECT * FROM peaks_location";
	$stmt = mysqli_prepare($conn,$query);		

	mysqli_stmt_execute($stmt);
	mysqli_stmt_bind_result($stmt, $row->id, $row->name, $row->elevation, $row->latitude, $row->longitude, $row->prominence, $row->range, $row->isolation, $row->state, $row->wa_bulger_list);
	
	
	
	
	while (mysqli_stmt_fetch($stmt)) {
		printf ("<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>"
		, $row->id, $row->name, $row->elevation, $row->latitude, $row->longitude, $row->prominence, $row->range, $row->isolation, $row->state, $row->wa_bulger_list);
	}
	
	mysqli_stmt_free_result($stmt);
	mysqli_close($conn);

?>

<?php
	
?>
</table>
</body>
</html>
